function [R,O,G,C,B] = ARIdemosaicking(R,O,G,C,B)

% mask
img_size = size(R);
MR = Rmosaic(ones(img_size));
MO = Omosaic(ones(img_size));
MG = Gmosaic(ones(img_size));
MC = Cmosaic(ones(img_size));
MB = Bmosaic(ones(img_size));
mask = cat(3,MR,MG,MB,MO,MC);

% mosaic images
mosaic = cat(3,R,G,B,O,C);

% guided filer epsilon
eps = 1e-6;

% green interpolation
G = green_interpolation(mosaic,mask,eps);

% rocb interpolation
[R, O, C, B] = rocb_interpolation_first(G, mosaic, mask, eps);
[R, O, C, B] = rocb_interpolation_second(G, R, O, C, B, mask, eps);
[R, O, C, B] = rocb_interpolation_third(G, R, O, C, B, mask, eps);

end
