function Lab = XYZ2Lab(XYZ)

% Normalize for D65 white point
X = XYZ(:,:,1) / 0.95046;
Y = XYZ(:,:,2);
Z = XYZ(:,:,3) / 1.08906;

Lab = zeros(size(XYZ));
Lab(:,:,1)=116*f(Y)-16;
Lab(:,:,2)=500*(f(X)-f(Y));
Lab(:,:,3)=200*(f(Y)-f(Z));

% internal function
function d = f(t)
    
d = t.^(1/3);
d(t<=0.008856)=7.787*t(t<=0.008856)+16/116;

end

end
