%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Spectral reflectance estimation
%
% Date     : 3 May 2014
% Author   : Yusuke Monno
%
% [PARAMETERS]
% es_r      : output reflectance datacube
% R,O,G,C,B : imput 5-band images
% H         : system matrix
% Basis     : spectral basis
% reg       : regularization paremter
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function es_r = es_ref5(R,O,G,C,B,H,Basis,reg)

% Spectral estimation
I = im2vec(cat(3,B,C,G,O,R));
P = diff(Basis,2,1);
F = H*Basis;
F2 =[F',reg*P']';
Z = zeros(size(I,2),size(P,1));
I2 = [I',Z]';
alpha = (F2'*F2)\F2'*I2;
es_r = Basis*alpha;
es_r = clip(es_r,0,1);

end